#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rnd(time(0));

#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define f first
#define s second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pb push_back
#define eb emplace_back


template <class T>
ll upmax(T &a, T b){return (b>a) ? a = b,1 : 0;}

template <class T>
ll upmin(T &a, T b){return (b<a) ? a = b,1 : 0;}


void solve(){
    ll n,m;
    cin>>n>>m;

    auto getStupidV = [&](){
        ll arr[n][m];
        for(int i = 0,cnt = 1;i<n;i++){
            for(int j = 0;j<m;j++){
                arr[i][j] = cnt++;
            }
        }
        ll suml = 0,allsum = (n*m) * (n*m+1) / 2;
        vector<pair<ll,ll>> ans;
        for(int j = 0;j<m;j++){
            int x = 0;
            for(int i = 0;i<n;i++){
                suml+=arr[i][j];
                x+=arr[i][j];
            }
            ans.eb(abs(allsum - suml - suml), j + 2);
        }
        sort(all(ans), [&](pair<ll,ll> &a, pair<ll,ll> &b){
            if(a.f == b.f)return a.s < b.s;
            return a.f < b.f;
        });
        return ans[0];
    };

//    auto x = getStupidV();
//    cout<<x.s<<'\n';

    auto fastV = [&](){
        ll a = 1;
        ll b = (n - 1) * m + 1;
        ll sum0 = (n* (a + b) / 2);
        ll allsum = (n*m) * (n*m+1) / 2;
        int l = 0,r = m;
        ll suml = 0,sumr;
        while(l + 2 < r){
            ll m1 = (r - l) / 3 + l;
            ll m2 = 2 * (r - l) / 3 + l;

            ll m1t = n * (m1 + ((n-1)*m) + m1) / 2;
            suml = m1 * (sum0 + m1t) / 2;
            ll m2t = n * (m2 + ((n-1)*m) + m2) / 2;
            sumr = m2 * (sum0 + m2t) / 2;

//            cout<<l<<' '<<r<<' '<<m1<<' '<<m2<<'\n';
//            cout<<suml<<' '<<sumr<<' '<<abs(allsum - suml - suml)<<' '<<abs(allsum - sumr - sumr)<<'\n';
//            cout<<'\n';

            if(abs(allsum - suml - suml) < abs(allsum - sumr - sumr)){
                r = m2;
            }else{
                l = m1;
            }
        }
        vector<pair<ll,ll>> ans;
        ll m1t = n * (l + ((n-1)*m) + l) / 2;
        suml = l * (sum0 + m1t) / 2;
        ans.eb(abs(allsum - suml - suml),l+1);
        l++;
        m1t = n * (l + ((n-1)*m) + l) / 2;
        suml = l * (sum0 + m1t) / 2;
        ans.eb(abs(allsum - suml - suml),l+1);
        sort(all(ans));
        return ans[0];
    };

    auto fastH = [&](){
        ll a = 1;
        ll b = m;
        ll sum0 = (n* (a + b) / 2);
        ll allsum = (n*m) * (n*m+1) / 2;
        int l = 0,r = n;
        ll suml = 0,sumr = 0;
        while(l + 2 < r){
            ll m1 = (r - l) / 3 + l;
            ll m2 = 2 * (r - l) / 3 + l;

            ll m1t = m * (m * m1 + 1 + m*m1 + m) / 2;
            suml = m1 * (sum0 + m1t) / 2;

            ll m2t = m * (m * m2 + 1 + m * m2 + m) / 2;
            sumr = m2 * (sum0 + m2t) / 2;

            if(abs(allsum - suml - suml) < abs(allsum - sumr - sumr)){
                r = m2;
            }else{
                l = m1;
            }
        }

        vector<pair<ll,ll>> ans;
        ll m1t = m * (m * l + 1 + m*l + m) / 2;
        suml = (l+1) * (sum0 + m1t) / 2;
        ans.eb(abs(allsum - suml - suml), l + 2);
        l++;
        m1t = m * (m * l + 1 + m*l + m) / 2;
        suml = (l+1) * (sum0 + m1t) / 2;
        ans.eb(abs(allsum - suml - suml), l + 2);

        sort(all(ans));
        return ans[0];
    };

    auto a = fastV();
    auto b = fastH();
//    cout<<a.f<<' '<<b.f<<'\n';
    if(a.f <= b.f){
        cout<<"V "<<a.s<<'\n';
    }else{
        cout<<"H "<<b.s<<'\n';
    }
}



int main() {
//    ioss
    int t = 1;
    cin>>t;
    while(t-->0){
        solve();
    }
    return 0;
}
